// Copyright 2011-2022 XMOS LIMITED.
// This Software is subject to the terms of the XMOS Public Licence: Version 1.
/** XUD_CRC5_Table.S
  * @brief     Full USB CRC5 table
  * @author    Ross Owen, XMOS Limited
  */

.section .dp.data, "adw", @progbits
.globl crc5Table
.type crc5Table, @object
.cc_top crc5Table.func, crc5Table
.align 4
crc5Table:
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0xf
.byte 0x10
.byte 0x18
.byte 0x7
.byte 0x8
.byte 0x17
.byte 0x1f
.byte 0x0
.byte 0x1
.byte 0x1e
.byte 0x16
.byte 0x9
.byte 0x6
.byte 0x19
.byte 0x11
.byte 0xe
.byte 0x13
.byte 0xc
.byte 0x4
.byte 0x1b
.byte 0x14
.byte 0xb
.byte 0x3
.byte 0x1c
.byte 0x1d
.byte 0x2
.byte 0xa
.byte 0x15
.byte 0x1a
.byte 0x5
.byte 0xd
.byte 0x12
.byte 0x1e
.byte 0x1
.byte 0x9
.byte 0x16
.byte 0x19
.byte 0x6
.byte 0xe
.byte 0x11
.byte 0x10
.byte 0xf
.byte 0x7
.byte 0x18
.byte 0x17
.byte 0x8
.byte 0x0
.byte 0x1f
.byte 0x2
.byte 0x1d
.byte 0x15
.byte 0xa
.byte 0x5
.byte 0x1a
.byte 0x12
.byte 0xd
.byte 0xc
.byte 0x13
.byte 0x1b
.byte 0x4
.byte 0xb
.byte 0x14
.byte 0x1c
.byte 0x3
.byte 0x4
.byte 0x1b
.byte 0x13
.byte 0xc
.byte 0x3
.byte 0x1c
.byte 0x14
.byte 0xb
.byte 0xa
.byte 0x15
.byte 0x1d
.byte 0x2
.byte 0xd
.byte 0x12
.byte 0x1a
.byte 0x5
.byte 0x18
.byte 0x7
.byte 0xf
.byte 0x10
.byte 0x1f
.byte 0x0
.byte 0x8
.byte 0x17
.byte 0x16
.byte 0x9
.byte 0x1
.byte 0x1e
.byte 0x11
.byte 0xe
.byte 0x6
.byte 0x19
.byte 0x15
.byte 0xa
.byte 0x2
.byte 0x1d
.byte 0x12
.byte 0xd
.byte 0x5
.byte 0x1a
.byte 0x1b
.byte 0x4
.byte 0xc
.byte 0x13
.byte 0x1c
.byte 0x3
.byte 0xb
.byte 0x14
.byte 0x9
.byte 0x16
.byte 0x1e
.byte 0x1
.byte 0xe
.byte 0x11
.byte 0x19
.byte 0x6
.byte 0x7
.byte 0x18
.byte 0x10
.byte 0xf
.byte 0x0
.byte 0x1f
.byte 0x17
.byte 0x8
.size crc5Table, .-crc5Table
.cc_bottom crc5Table.func
