# lib_qspi_fast_read Repository

`lib_qspi_fast_read` is a library for interfacing with a QSPI flash device on an XMOS device. This library achieves higher data transfer bandwidth than the default supplied flash libraries at the cost of flexiblity and write/erase functions.

## Build Status

Build Type       |    Status     |
-----------      | --------------|
CI (Linux)       | ![CI](https://github.com/xmos/lib_qspi_fast_read/actions/workflows/ci.yml/badge.svg?branch=develop&event=push) |
Docs             | ![CI](https://github.com/xmos/lib_qspi_fast_read/actions/workflows/docs.yml/badge.svg?branch=develop&event=push) |

## Cloning

Some dependent components are included as git submodules. These can be obtained by cloning this repository with the following command:

    $ git clone --recurse-submodules https://github.com/xmos/lib_qspi_fast_read.git

## Documentation

See the READMEs for the early example applications:

[General Use](https://github.com/xmos/lib_qspi_fast_read/blob/develop/examples/general_use/README.md)


# Getting Help

A [Github issue](https://github.com/xmos/lib_qspi_fast_read/issues) should be the primary method of getting in touch with the XMOS development team.

## License

This Software is subject to the terms of the [XMOS Public Licence: Version 1](https://github.com/xmos/lib_qspi_fast_read/blob/develop/LICENSE.rst)

